"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = __importStar(require("react"));
var styled_components_1 = __importDefault(require("styled-components"));
var asRendition_1 = __importDefault(require("../../asRendition"));
var utils_1 = require("../../utils");
var Txt_1 = __importDefault(require("../Txt"));
var shades = [
    '#C7FFFF',
    '#BAECC2',
    '#FFD4F1',
    '#F1CDE3',
    '#D7E4FE',
    '#FFD5D2',
    '#CAE1AC',
    '#D6D3FA',
    '#C3C7CA',
    '#FFDA93',
    '#E1EEE5',
    '#DBE0E3',
    '#FEEC63',
    '#FBE6F4',
    '#FFECAE',
    '#F1CDFF',
    '#C3EFFF',
    '#F3E8FD',
    '#E0FEB4',
    '#FDE8E7',
    '#CAFECD',
    '#D7E46C',
    '#F7D8BA',
];
var BaseBadge = styled_components_1.default(Txt_1.default.span)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n\tfont-family: ", ";\n\tdisplay: inline-block;\n\tborder-radius: 1em;\n\tline-height: 1;\n"], ["\n\tfont-family: ", ";\n\tdisplay: inline-block;\n\tborder-radius: 1em;\n\tline-height: 1;\n"])), function (props) { return props.theme.titleFont; });
var Badge = function (_a) {
    var children = _a.children, className = _a.className, shade = _a.shade;
    if (typeof children !== 'string') {
        throw new Error("The child element of the Badge component must be a string, received: " + typeof children);
    }
    var shadeHex = shades[(shade || 0) % shades.length];
    return (React.createElement(BaseBadge, { className: className, py: 1, px: "12px", fontSize: 0, bg: shadeHex, color: utils_1.getLegibleTextColor(shadeHex) }, children));
};
exports.default = asRendition_1.default(Badge);
var templateObject_1;
